/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#define BPMODE_FUNDAMENTAL 0
#define BPMODE_FIFTH		1
#define BPMODE_THIRD		2
#define BPMODE_SEVENTH	3

#ifdef DEBUG
#include <iostream.h>
#endif

void FormBpmCalc::init()
{
    freq = 440.0 ;
    lineFreq->setText( QString::number( freq, 'f', 3 ));
}

void FormBpmCalc::CalcBpmFromFreq()
{
    double bfreq ;
    double a ;
    double b ;
    
#ifdef DEBUG
    cout << "BpmMode = " << BpmMode << endl ;
    cout << "freq = " << freq << endl ;
#endif
    
    switch( BpmMode )
    {
    case BPMODE_FIFTH:
	a = freq ;
	a *= pow( 2, 0.583333333333333333 );	// 7/12
	b = freq ;
	b *= 1.5 ;
	bfreq = b - a ;		// 2 ^(7/12) <1.5
	// if( bfreq < 0 ) bfreq = a-b ;
	break ;
    case BPMODE_THIRD:
	a = freq ;
	a *= pow( 2, 0.333333333333333333 );	// 4/12
	b = freq ;
	b *= 1.25 ;
	bfreq = a - b ;		// 2^(4/12)>1.25
	//if( bfreq < 0 ) bfreq = b - a ;
	break ;
    case BPMODE_SEVENTH:
	a = freq ;
	a *= pow( 2, 0.833333333333333333 );	// 10/12 
	b = freq ;
	b *= 1.75 ;
	bfreq = a - b ;
	// if( bfreq < 0 ) bfreq = b-a ;
	break;
    case BPMODE_FUNDAMENTAL:
    default:
	a = freq ;
	b = freq ;
	bfreq = freq ;
	break ;
    };
    
#ifdef DEBUG    
    cout << "a = " << a << endl ;
    cout << "b = " << b << endl ;
    cout << "bfreq = " << bfreq << endl ;
#endif
    
    if( bfreq < 0 ) bfreq = 0 - bfreq ;
    
    while( bfreq > 2.5 )		// 2.5Hz == 150 bpm
    {
        bfreq /= 2 ;
    }

    while( bfreq < 1 ) bfreq *= 2 ;
    
    double bpm = bfreq * 60 ;
    
    lineBPM->setText( QString::number( bpm, 'f', 3 ));
}


void FormBpmCalc::SetFrequency( double newfreq )
{
    freq = newfreq ;
    lineFreq->setText( QString::number( freq, 'f', 3 ) );
}


void FormBpmCalc::pushA_clicked()
{
    SetFrequency( 440.0 );
    CalcBpmFromFreq();
}


void FormBpmCalc::pushASh_clicked()
{
    SetFrequency( 466.164 );
    CalcBpmFromFreq();
}


void FormBpmCalc::pushB_clicked()
{
    SetFrequency( 493.883 );
    CalcBpmFromFreq();
}


void FormBpmCalc::pushC_clicked()
{
    SetFrequency( 523.251 );
    CalcBpmFromFreq();
}


void FormBpmCalc::pushCSh_clicked()
{
    SetFrequency( 554.365 );
    CalcBpmFromFreq();
}


void FormBpmCalc::pushD_clicked()
{
    SetFrequency( 587.330 );
    CalcBpmFromFreq();
}


void FormBpmCalc::pushDSh_clicked()
{
    SetFrequency( 622.254 );
    CalcBpmFromFreq();
}


void FormBpmCalc::pushE_clicked()
{
    SetFrequency( 659.255 );
    CalcBpmFromFreq();
}


void FormBpmCalc::pushF_clicked()
{
    SetFrequency( 698.456 );
    CalcBpmFromFreq();
}


void FormBpmCalc::pushFSh_clicked()
{
    SetFrequency( 739.989 );
    CalcBpmFromFreq();
}


void FormBpmCalc::pushG_clicked()
{
    SetFrequency( 783.991 );
    CalcBpmFromFreq();
}


void FormBpmCalc::pushGSh_clicked()
{
    SetFrequency( 830.609 );
    CalcBpmFromFreq();
}




// Mode buttons
void FormBpmCalc::radioFun_clicked()
{
    BpmMode = BPMODE_FUNDAMENTAL ;
    CalcBpmFromFreq();
}


void FormBpmCalc::radioFifth_clicked()
{
    BpmMode = BPMODE_FIFTH ;
    CalcBpmFromFreq();
}


void FormBpmCalc::radioMaj3_clicked()
{
    BpmMode = BPMODE_THIRD ;
    CalcBpmFromFreq();
}


void FormBpmCalc::radioMin7_clicked()
{
    BpmMode = BPMODE_SEVENTH ;
    CalcBpmFromFreq();
}
